from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
import sys

class Engine(object):
    def __init__(self):
        self.window = None
        
    def initGL(self, Width, Height):
        glClearColor(0.0, 0.0, 0.0, 0.0)

        glClearDepth(1.0)
        glDepthFunc(GL_LESS)
        glEnable(GL_DEPTH_TEST)
        glShadeModel(GL_SMOOTH)
        glMatrixMode(GL_PROJECTION)
        glLoadIdentity()

        # Calculate The Aspect Ratio Of The Window
        gluPerspective(45.0, float(Width)/float(Height), 0.1, 100.0)
        glMatrixMode(GL_MODELVIEW)

    def resizeGLScene(self, Width, Height):
        if Height == 0:
	    Height = 1
            glViewport(0, 0, Width, Height)
            glMatrixMode(GL_PROJECTION)
            glLoadIdentity()
            gluPerspective(45.0, float(Width)/float(Height), 0.1, 100.0)
            glMatrixMode(GL_MODELVIEW)

    def keyPressed(self, *args):
        if args[0] == '\033':
            sys.exit()

    def run(self):
        glutInit(sys.argv)

	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH)

	# get a 640 x 480 window
	glutInitWindowSize(640, 480)
	glutInitWindowPosition(0, 0)

	self.window = glutCreateWindow("Demo OpenGL")

	glutDisplayFunc(self.drawGLScene)

	#glutFullScreen()

	glutIdleFunc(self.drawGLScene)

	glutReshapeFunc(self.resizeGLScene)

	# Register the function called when the keyboard is pressed.
	glutKeyboardFunc(self.keyPressed)

	# Initialize our window
	self.initGL(640, 480)

	# Start Event Processing Engine
	glutMainLoop()

