from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *

from engine import Engine

class Volume(Engine):
    def __init__(self):
        Engine.__init__(self)
        
        self.rtri = 0.0
        self.rquad = 0.0

    def drawGLScene(self):
        # Reset The View
        glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
        glLoadIdentity()

	# Move Left 1.5 units and into the screen 6.0 units.
	glTranslatef(-1.5, 0.0, -6.0)

	# Draw a triangle        
        glRotatef(self.rtri, 0.0, 1.0, 0.0)      # Rotate

        glBegin(GL_TRIANGLES);
        glColor3f(1.0,0.0,0.0);			# Red
	glVertex3f( 0.0, 1.0, 0.0);		# Top Of Triangle (Front)
	glColor3f(0.0,1.0,0.0);			# Green
	glVertex3f(-1.0,-1.0, 1.0);		# Left Of Triangle (Front)
	glColor3f(0.0,0.0,1.0);			# Blue
	glVertex3f( 1.0,-1.0, 1.0);

	glColor3f(1.0,0.0,0.0);			# Red
	glVertex3f( 0.0, 1.0, 0.0);		# Top Of Triangle (Right)
	glColor3f(0.0,0.0,1.0);			# Blue
	glVertex3f( 1.0,-1.0, 1.0);		# Left Of Triangle (Right)
	glColor3f(0.0,1.0,0.0);			# Green
	glVertex3f( 1.0,-1.0, -1.0);		# Right

	glColor3f(1.0,0.0,0.0);			# Red
	glVertex3f( 0.0, 1.0, 0.0);		# Top Of Triangle (Back)
	glColor3f(0.0,1.0,0.0);			# Green
	glVertex3f( 1.0,-1.0, -1.0);		# Left Of Triangle (Back)
	glColor3f(0.0,0.0,1.0);			# Blue
	glVertex3f(-1.0,-1.0, -1.0);		# Right Of

	glColor3f(1.0,0.0,0.0);			# Red
	glVertex3f( 0.0, 1.0, 0.0);		# Top Of Triangle (Left)
	glColor3f(0.0,0.0,1.0);			# Blue
	glVertex3f(-1.0,-1.0,-1.0);		# Left Of Triangle (Left)
	glColor3f(0.0,1.0,0.0);			# Green
	glVertex3f(-1.0,-1.0, 1.0);		# Right Of Triangle (Left)
	glEnd();

        # VERY important
        glLoadIdentity()
        
	# Move Right 3.0 units.
        glTranslatef(1.5, 0.0, -6.0)

	# Draw a square (quadrilateral)
        
        glRotatef(self.rquad, 1.0, 1.0, 0.0)	    # Rotate

	glBegin(GL_QUADS)                   # Start drawing a 4 sided polygon

        glColor3f(0.0,1.0,0.0);			# Set The Color To Blue
	glVertex3f( 1.0, 1.0,-1.0);		# Top Right Of The Quad (Top)
	glVertex3f(-1.0, 1.0,-1.0);		# Top Left Of The Quad (Top)
	glVertex3f(-1.0, 1.0, 1.0);		# Bottom Left Of The Quad (Top)
	glVertex3f( 1.0, 1.0, 1.0);		# Bottom Right Of The Quad (To)

	glColor3f(1.0,0.5,0.0);			# Set The Color To Orange
	glVertex3f( 1.0,-1.0, 1.0);		# Top Right Of The Quad (Bottom)
	glVertex3f(-1.0,-1.0, 1.0);		# Top Left Of The Quad (Bottom)
	glVertex3f(-1.0,-1.0,-1.0);		# Bottom Left Of The Quad (Bottom)
	glVertex3f( 1.0,-1.0,-1.0);		# Bottom Right Of The Quad (Bottom)

	glColor3f(1.0,0.0,0.0);			# Set The Color To Red
	glVertex3f( 1.0, 1.0, 1.0);		# Top Right Of The Quad (Front)
	glVertex3f(-1.0, 1.0, 1.0);		# Top Left Of The Quad (Front)
	glVertex3f(-1.0,-1.0, 1.0);		# Bottom Left Of The Quad (Front)
	glVertex3f( 1.0,-1.0, 1.0);		# Bottom Right Of The Quad (Front)

	glColor3f(1.0,1.0,0.0);			# Set The Color To Yellow
	glVertex3f( 1.0,-1.0,-1.0);		# Bottom Left Of The Quad (Back)
	glVertex3f(-1.0,-1.0,-1.0);		# Bottom Right Of The Quad (Back)
	glVertex3f(-1.0, 1.0,-1.0);		# Top Right Of The Quad (Back)
	glVertex3f( 1.0, 1.0,-1.0);		# Top Left Of The Quad (Back)

	glColor3f(0.0,0.0,1.0);			# Set The Color To Blue
	glVertex3f(-1.0, 1.0, 1.0);		# Top Right Of The Quad (Left)
	glVertex3f(-1.0, 1.0,-1.0);		# Top Left Of The Quad (Left)
	glVertex3f(-1.0,-1.0,-1.0);		# Bottom Left Of The Quad (Left)
	glVertex3f(-1.0,-1.0, 1.0);		# Bottom Right Of The Quad (Left)

	glColor3f(1.0,0.0,1.0);			# Set The Color To Violet
	glVertex3f( 1.0, 1.0,-1.0);		# Top Right Of The Quad (Right)
	glVertex3f( 1.0, 1.0, 1.0);		# Top Left Of The Quad (Right)
	glVertex3f( 1.0,-1.0, 1.0);		# Bottom Left Of The Quad (Right)
	glVertex3f( 1.0,-1.0,-1.0);		# Bottom Right Of The Quad (Right)
	glEnd()                             # We are done with the polygon

	# Double buffer, swap
	glutSwapBuffers()

        self.rtri += 1
        self.rquad -= 1


if __name__ == "__main__":
    gl = Volume()
    gl.run()
